(*
   SNU 4190.310 (2004 fall) HW5
   Main Interface for K
   Jaeho Shin <netj@ropas.snu.ac.kr>
*)

val print_k_code = ref false
val check_type = ref false
val spec = [
    ("-pp", Arg.Set print_k_code, "Print K program"),
    ("-ty", Arg.Set check_type, "Check types before running (with low fat K)")
]
val usage = "Usage: run [<options>] <K file> \n<options> are: "

fun run () =
    let val filename = ref ""
        val _ = Arg.parse spec
                (fn x => if Sys.file_exists x then filename := x
                    else raise Arg.Bad (x^": No such file")) usage
    in  if !filename = "" then Arg.usage spec usage else (
            Error.init ();
            let val pgm = Parser.program Lexer.start (
                        Lexing.from_channel (open_in !filename))
            in  if !print_k_code then (
                    print_string "== Input Program ==\n"; 
                    K_Printer.print pgm;
                    print_newline()
                );
                if !check_type then (
                    print_string "== Type Checking ==\n";
                    K_Printer.printTypes (K_Checker.check pgm);
                    print_string "== Running with Low Fat K ==\n";
                    K_LowFat.run pgm
                ) else (
                    print_string "== Running with Vanilla K ==\n";
                    K_Vanilla.run pgm
                )
            end handle v => Error.handle_exn v
        )
    end

val _ = Printexc.catch run () 
