/*
   SNU 4190.310 (2004 fall) HW5
   Parser for K
*/

%{       
exception EmptyBinding         
val rec desugarLet =
  fn (nil, e) => raise EmptyBinding
   | (a::nil, e) => K.LET(a,e)
   | (a::r, e) => K.LET(a, desugarLet(r,e))
   
exception IncorrectSelection
val whichSel = fn (e, 1) => K.SEL1 e
			| (e, 2) => K.SEL2 e
			| _ => raise IncorrectSelection
%}
  
%token TRUE FALSE AND OR IF THEN ELSE LET IN END FN READ WRITE RARROW EQUAL
%token PLUS MINUS LP RP VAL COLONEQ BANG MALLOC SEMICOLON REC EOF DOT COMMA
%token <int> NUM
%token <string> ID
%token <string> STRING

%left SEMICOLON         
%right FN RARROW LET 
%right WRITE
%right COLONEQ         
%nonassoc IF THEN ELSE
%left EQUAL 
%left PLUS MINUS OR
%left AND
%right BANG MALLOC
%left DOT 
%nonassoc TRUE FALSE NUM ID STRING READ LP

%start program
%type <K.exp> program
%type <K.exp> expr
%type <K.decl> decl         
%type <K.decl list> decls         

%%
program: expr EOF   {$1}
     ;
expr: aexpr {$1}
    | expr aexpr {K.APP($1,$2)}
    | expr PLUS expr {K.BOP(K.ADD,$1,$3)}
    | expr MINUS expr {K.BOP(K.SUB,$1,$3)}
    | expr EQUAL expr {K.BOP(K.EQ,$1,$3)}
    | expr AND expr {K.BOP(K.AND,$1,$3)}
    | expr OR expr {K.BOP(K.OR,$1,$3)}
    | expr SEMICOLON expr {K.SEQ ($1,$3)}
    | expr COLONEQ expr {K.ASSIGN($1,$3)}
	| expr DOT NUM {whichSel ($1,$3)}
    ;
aexpr: LP expr RP {$2}
    | NUM {K.CONST(K.N $1)}
    | STRING {K.CONST(K.S $1)}
    | TRUE {K.CONST(K.B true)}
    | FALSE {K.CONST(K.B false)}
    | ID {K.VAR($1)}
    | READ {K.READ}
    | FN ID RARROW expr {K.FN($2,$4)}
    | LET decls IN expr END {desugarLet($2,$4)}
    | IF expr THEN expr ELSE expr {K.IF($2,$4,$6)}
    | WRITE expr {K.WRITE ($2)}
    | MALLOC expr {K.MALLOC ($2)}
    | BANG expr {K.BANG ($2)}
	| LP expr COMMA expr RP {K.PAIR ($2,$4)}
    ;        
decls: decl {[$1]}
    | decls decl {$1 @ [$2]}
    ;    
decl: VAL ID EQUAL expr {K.NREC($2, $4)}
    | REC ID EQUAL FN ID RARROW expr {K.REC($2,K.FN($5,$7))}
    ;
%%
